
; *****************************************************************************************
;			Fichier: FPILOT1.ASM			08/06/04	10H
;	
; *****************************************************************************************

; Ce programme gre l'envoi d'ordres HF via un 145026 pour pouvoir piloter un radiateur
; lectrique  fil pilote. Une horloge avec un inter (ouvert: mode confort et ferm pour le 
; mode temprature rduite) est associe  ce module  PIC afin de raliser un gestionnaire
; de chauffage programmable. 
; Pderog sert  deroger le mode en cours jusqu'au changement suivant prvu par l'horloge,
; L'inter K(HG) sert  imposer le mode Hors gel 
; La led bicolore visualise l'tat en cours. Rouge confort, orange rduit, vert hors gel,
; En cas de drogation, la led clignote. On ne peut pas droger au hors gel.
; La base de temps gnre par le PIC sert  mettre (rafraichissement) le code en cours 
; toutes les 8mn environ sur la base d'un quartz  4MHz. 
; 
; 
; PA1	reoit 	le contact horaire	PIN 18	ouvert "0V" confort ferm "5V" rduit
; PA2 	reoit	le contact K (Hors GEL) 0V: normal; 5V: Hors Gel
; PA3 	reoit	le poussoir Pderog "0V" au repos
	
; PB0	gre	led rouge mode confort
; PB1	gre 	led verte mode hors gel (avec les 2 on a de l'orange)	 
; PB2 	gre	le mode clignotant ou fixe PB2 est invers toutes les secondes par it	 

; PB4	gre 	code 1	alternances positives	
; PB5	gre	code 2	alternances ngatives
; PB6	gre	TE/ pour l'envoi des codes mis  1 au repos


	list	p=16f84
	#include p16f84.inc
	
; directives assembleur	pour aller + vite et mieux comprendre ce qui est test ou impos	

#define	testc	STATUS,C	; testc pour tester le bit C (= carry ) de STATUS
#define	testz	STATUS,Z	; testz remplace STATUS,Z
#define	banq	STATUS,RP0	; banq remplace STATUS,RP0	etc...

#define	tebar	PORTB,6		; validation du 145026	par niveau "0" (=1 au repos)
#define fixcli	PORTB,2		; active ou non le clignottement
#define C_H	PORTA,1		; contact horloge
#define K_HG	PORTA,2		; contact hors gel
#define Pderog	PORTA,3		; poussoir Pderog

#define	tocs	OPTION_REG,T0CS		; timer en service en mettant 0
#define	psa	OPTION_REG,PSA		; prdiviseur pour timer en mettant 0
#define toie	INTCON,T0IE		; autorise interruption timer
#define toif	INTCON,T0IF		; passe  1 en cas d'interruption timer
#define	gie	INTCON,GIE		; mettre  1 pour autoriser les it

#define	K_old	temoin,0	; on y met l'tat de l'inverseur hors gel
#define	CH_old	temoin,1	; "	" 	  du contact horaire
#define	derog	temoin,2	; vaut 1 si derogation demande sinon "0"
#define	envcod	temoin,3	; mis  1 pour imposer un envoi de code

; dfinition des variables en RAM utilises comme registre
 
ms1	equ 	0x10		; variable de la tempo d'une milli-seconde
cnt	equ 	0x11		; utiliss par le sous prog ms_1 (tempo de 1ms)
ms10	equ	0x12		; variable contenant la dure multiple de 10ms (0< <255)
nb_bou	equ	0x13		; variable de comptage de boucle pour lire portB 
BT1	equ	0x14		; mis  16 pour dfinir un clignotement de 1 s
BT2	equ 	0x15		; mis  125 pour dfinir une dure de 2mn environ 
BT3	equ	0x16		; mis  4 pour arriver  8mn  (priode entre 2 missions)
temoin	equ	0x17		; contient K_old, CH_old, derog, envcod
mot_cod	equ	0x18		; contient le code passant dans portB pour leds et mission
w_temp	equ	0x19
status_temp	equ 0x1A
		
confort	equ	0x45		; code d'allumage leds et d'mission pour le mode confort
reduit	equ	0x77		;	"				"    reduit
horsgel	equ	0x66		;	"				"    hors gel


; ********************************************************************************
; 		vecteurs de dmarrage et d'interruption
;*********************************************************************************
	org	0		; ne pas mettre 0x000 sinon PB

	goto 	DEBUT		

	org 	4		; ne pas mettre 0x004 sinon pB
	goto	gest_it		; vecteur d'it

;************************************************************************************
; ****		 ms_1 			tempo de 1ms 				*****
;  	appel avec chargement de dure dans w et utilisation de cnt et ms1
; 	si on veut 1 ms sans  charger w, appeler une_ms
;************************************************************************************

une_ms	movlw	1
ms_1	movwf	ms1
ms1a	movlw	.249		; ici on charge une boucle de 249 pas 
	movwf	cnt
ms1b	decf	cnt,1
	btfss	testz		; que l'on dcrmente pour faire la tempo de 1ms
	goto	ms1b
	decfsz	ms1,1
	goto	ms1a
	return
	
; **************************************************************************************
; ***		ms_10		**** 	sous programme tempo de 10ms	***
;  dure allant de 1  2550ms (= 2,5s) passe par w et mise dans ms10 utilise ms_1 et cnt
;	pour ne pas charger w, on peut appeler directement dix_ms pour 10ms
; **************************************************************************************

dix_ms	movlw	1
ms_10	movwf	ms10
ms10a	movlw	.10		; on charge ms1  10ms
	movwf	ms1
ms10b	movlw	.249		; ici on charge une boucle de 249 pas 
	movwf	cnt
ms10c	decf	cnt,1
	btfss	testz		; que l'on dcrmente pour faire la tempo de 1ms
	goto	ms10c
	decfsz	ms1,1
	goto	ms10b
	decfsz	ms10,1		; on dcrmente ms10 puis on teste si ms10 arrive  0
	goto	ms10a		; on rapelle ms_1 charg  10ms
	return			; jusqu' ce que la tempo voulue soit atteinte
	
;*************************************************************************************
; ***		env_cod		**** 	envoi du code et allumage des leds   ***
;  
;**************************************************************************************

env_cod	bcf	gie		; it interdites pendant l'mission du code
	movlw	.16		; chargement de BT1  16
	movwf	BT1		; pour redmarrage la tempo entre 2 missions HF
	movlw	.125		; idem pour BT2 avec 125 et BT3 avec 4
	movwf	BT2		; avec BT1=16 clignottement de T=2 x 1s=2s
	movlw	4
	movwf	BT3
	movf	mot_cod,0	; on  fait passer le code  mettre dans W
	movwf	PORTB		; entraine l'allumage appropri et charge le code
	bcf	tebar		; envoi du code en mettant tebar  0
	movlw	.140		; appel tempo de 1,4s dure d'envoi du code.
	call	ms_10		; 
	bsf	tebar		; retour au repos pour TE/
	bcf	envcod		; 
	bsf	gie		; autorisation globale des it 

	return


; **************************************************************************************
; **************************************************************************************
;				programme principal
; **************************************************************************************
; **************************************************************************************

DEBUT	bsf	banq		; selection bank 1
	bcf	tocs		; timer en service
	bcf	psa		; prdiviseur attribu au timer
	clrf	TRISB		; PORTB en sortie
	bcf	banq		; retour bank 0

inisuit
;*****	movlw	8		; chargement de BT1  8
;	movwf	BT1		; pour redmarrage la tempo entre 2 missions HF
;	movlw	.250		; idem pour BT2 avec 250 et BT3 avec 4
;	movwf	BT2
;	movlw	4
;	movwf	BT3

	movlw	0x08		; initialisation de envcod=1, derog=0, ch_old=0, k_old=0
	movwf	temoin
	bcf	toif		; mettre  0 le flag d'it timer
	bsf	toie		; autorise les it timer 
;*****	bsf	gie		; autorise toute it non masque
	goto	bou_1		; aller lire l'tat des interrupteurs

bou_att	btfsc	envcod		; si envcod=1, on doit mettre le code sinon on va tester le
	call	env_cod		; contact horaire, K_HG et Pderog
bou_1	btfsc	K_HG		; si mode Hors Gel souhait, aller traiter ce cas
	goto	mod_hg
	btfss	K_old		; si K_HG=0 et K_old=1 attendre fin rebond,lire et modifier	
	goto	bou_2		; ici K_HG et K_old=0
	movlw	2
	call	ms_10		; attente 20ms avant de relire K_HG
	btfsc	K_HG
	goto	bou_att		; Pb de rebond ou erreur, retourner lire
	bsf	envcod		; K_HG=0 et K_old valait 1 ==> modif du code

bou_2	bcf	K_old		; on n'est pas en hors gel donc bit mis  0
	clrf	nb_bou		; initialisation du nb de boucles.
eta_CH	btfss	C_H
	goto	verif_c
verif_r	btfsc	CH_old		; CH=?CHold
	goto	t_derog		; ici CH=CHold=1 donc pas de changement: mode rduit
	call	dix_ms
	incf	nb_bou,1
	btfss	nb_bou,2
	goto	eta_CH		; tester si CH modifi pendant plus de 40ms
	movlw	reduit
	movwf	mot_cod		; chargement du nouveau code du mode reduit
	bsf	CH_old		; enregistrement de la nouvelle valeur de CH
	goto	eta_new

verif_c	btfss	CH_old
	goto	t_derog		; CH et CHold=0 donc pas de changement: mode confort
	call	dix_ms
	incf	nb_bou,1
	btfss	nb_bou,2
	goto	eta_CH		; tester si CH modifi pendant plus de 40ms
	movlw	confort
	movwf	mot_cod		; chargement du nouveau code du mode confort (car C_H=0)
	bcf	CH_old		; enregistrement du nouvel tat de CH

eta_new	bsf	envcod		; 
	btfsc	derog		; si derog=0 le laisser
	bcf	derog		; derog valait 1 avant le changement du contact horaire
	goto	bou_att		; retour pour envoi du code et nouvelle boucle

t_derog	btfsc	Pderog
	goto	pdero1		; verifier que Pderog a bien t activ.
t_dero2	btfss	derog		; si derog=1 inverser le mode de chauffage
	goto	actucod		; C_H n'a pas chang mais on actualise le code
codinv1	btfss	CH_old		
	goto	codinv3
	movlw	confort		; CH_old=1 et derog voulue (=1) ==> imposer le mode confort 
codinv2	movwf	mot_cod
	goto	bou_att
codinv3	movlw	reduit		; CH_old=0 et derog voulue (=1) ==> imposer le mode reduit
	goto	codinv2		

actucod	btfss	CH_old		
	goto	actuco3
	movlw	reduit		; CH_old=1 et derog =0 ==> imposer le mode reduit 
actuco2	movwf	mot_cod
	goto	bou_att
actuco3	movlw	confort		; CH_old=0 et derog =0 ==> imposer le mode confort
	goto	actuco2

pdero1	clrf	nb_bou
pdero1a	call	dix_ms
	btfss	Pderog		; si Pderog activ plus de 20ms, modifier l'tat de derog
	goto	t_dero2		; on peut aussi renvoyer vers t_derog
	incf	nb_bou,1
	btfss	nb_bou,1
	goto	pdero1a		; il n'y a pas encore 20ms que Pderog=1
	btfss	derog
	goto	pdero2
	bcf	derog		; inversion du bit derog
	goto	pdero3
pdero2	bsf	derog		; idem
pdero3	call 	dix_ms
	btfsc	Pderog		; attente relachement Pderog
	goto	pdero3		
	bsf	envcod		; prparer l'envoi d'un code
	goto	t_dero2	

mod_hg	call	dix_ms		; attente de 10ms avant relecture de l'tat de K hors gel
	btfss	K_HG
	goto	bou_att		; K_HG=0 donc tat normal (fin de hors gel)
	btfsc	K_old		; si K_old=0, le mettre  1, sinon actualiser mot_cod
	goto	mod_hg1
	bsf	K_old
	bsf	envcod		; on vient de passer en mode hors gel ==> envoi code
mod_hg1	bcf	derog		; supprime le clignottement en Hors gel
	movlw	horsgel
	movwf	mot_cod
	goto	bou_att

	
;			****	fin du programme principal	****

; **************************************************************************************
; 		gest_it 		gestion de l'it timer 
; **************************************************************************************

gest_it	movwf	w_temp		; sauvegarde de W dans w_temp
	swapf	STATUS,0	; sauvegarde status (invers) dans w sans modif bit z
	movwf	status_temp	; puis dans status_temp
	
; la routine d'it proprement dite dbute ici

	decfsz	BT1,1		; dcrmenter BT1, rsultat dans BT1, si BT1=0 recharger  16 
	goto	it_fin		; sinon sortir pour attendre 1s
	movlw	.16		; recharge de BT1  16
	movwf	BT1
	btfss	derog
	goto	it_2
	btfss	fixcli		; si derog=1 mode clignotant, ==> inverser fixcli
	goto	it_1
	bcf	fixcli		; on  invers fixcli de 1  0
	goto	it_2
it_1	bsf	fixcli		; passage  de fixcli de 0  1
it_2	decfsz	BT2,1		; dcrmenter BT2 dans BT2 et si rsultat nul, recharger BT2=250
	goto	it_fin
	movlw	.125		; BT2=0, le recharger  125
	movwf	BT2
	decfsz	BT3,1
	goto	it_fin
	movlw	4
	movwf	BT3		; recharger BT3=4 soit une BT totale de 8mn entre 2 missions
	bsf	envcod		; de codes successifs.

; rcupration de w et status avant sortie de l'it

it_fin	swapf	status_temp,0	; status retrouve son tat dans w
	movwf	STATUS		; puis repasse dans status sans modif de z
	swapf	w_temp,1
	swapf	w_temp,0	; w invers 2 fois revient  sa place bit Z non modifi
	bcf	toif		; effacement flag

 	retfie

	
	end


